#!/usr/bin/perl
#
# This code is distributed under the terms of the GPL
#
# (c) Tiago Freitas Leal
#
###2006-0422 - install.pl from QoS v1.8 by NetWhiz modded by catastrophe for use with enhancedipblock v.0.2
###2007-0107 - modded by catastrophe for use with NoWireAP v.0.2.0
###2007-0122 - modded by catastrophe for use with NoWireAP v.0.2.0

require '/var/smoothwall/mods/nowireap/modlib.pl';

# # # # # # # # # # # # # # # # # # #
# check for existing installations  #
# # # # # # # # # # # # # # # # # # #

print "\nInstalling NoWireAP v.0.2, please wait...\n\n";


#@finddriver=`find / -name ath_pci.o|grep ath_pci.o`

#if (-e "/var/smoothwall/mods/nowireap/installed") {
#	if (! )) {
#		print "\nYou have not installed ath_pci wireless drivers\n";
#		print "Please install them before continuing.\n \n";
#		exit;
#	}
#}


if (-e "/var/smoothwall/mods/nowireap/installed") {
	if (&installed ("/var/smoothwall/mods/nowireap/installed", "# nowireap v.0.2")) {
		print "\nPlease remove NoWireAP v.0.2\n";
		print "Note - Run uninstall.pl script.\n \n";
		exit;
	}
}

if (&installed ("/var/smoothwall/langs/base.pl", "# nowireap v.0.2")) {
	print "\nPlease remove NoWireAP v.0.2\n";
	print "Note - Run uninstall.pl script.\n \n";
	exit;
}

# # # # # # # # # # # #
# handle file copying #
# # # # # # # # # # # #

#	$storebkp =	where to store backup of the files that are changed by your mod
#	$moddir =	where your mod files are
#	$wkdir =	where you are changing files (backup from and copy to)
#
#	backupinstall ($file, $wkdir, $storebkp, $moddir);
#	backup ($file, $wkdir, $storebkp);
#	install ($file, $wkdir, $moddir);
#	uninstallrestore ($file, $wkdir, $storebkp);
#	uninstall ($file , $wkdir);
#
#	installed ($file, $string);
#
#	search for $string into $file => 1 found / 0 not found

my $bkp = '/var/smoothwall/mods/nowireap/backup';

print "Creating backups ...\n";

$dir = '/etc';
&backup ('ld.so.conf', $dir, $bkp);

$dir = '/etc/rc.d';
&backup ('rc.firewall.up', $dir, $bkp);

$dir = '/etc/rc.d';
&backup ('rc.netaddress.up', $dir, $bkp);

$dir = '/etc/rc.d';
&backup ('rc.network', $dir, $bkp);

$dir = '/etc/rc.d';
&backup ('rc.sysinit', $dir, $bkp);

$dir = '/home/httpd/cgi-bin';
&backup ('.htaccess', $dir, $bkp);

$dir = '/var/smoothwall/langs';
&backup ('base.pl', $dir, $bkp);

$dir = '/var/smoothwall/main/ui';
&backup ('alertboxes.en.pl', $dir, $bkp);

$dir = '/var/smoothwall';
&backup ('header.pl', $dir, $bkp);

my $mod = '/var/smoothwall/mods/nowireap/modfiles';

print "Installing new files ...\n";

$dir = '/etc/rc.d';
&install ('rc.wireless.update', $dir, $mod);

$dir = '/home/httpd/cgi-bin';
&install ('wireless.cgi', $dir, $mod);

$dir = '/home/httpd/html/help';
&install ('wireless.cgi.html.en', $dir, $mod);

print "Making any needed directories ...\n";

# # # # # # # # # # # #
# handle permissions  #
# # # # # # # # # # # #

# remove these lines when the web UI interface is ready
open (FILE, ">/var/smoothwall/preferences/dummy") or system ("/bin/su nobody -c '/bin/mkdir /var/smoothwall/preferences'");
close (FILE);
system ("/bin/rm -f /var/smoothwall/preferences/dummy");

# uncomment these lines when the web UI interface is ready
#open (FILE, ">/var/smoothwall/preferences/dummy") or system ("/bin/mkdir /var/smoothwall/preferences");
#close (FILE);
#system ("/bin/rm -f /var/smoothwall/preferences/dummy");

# # # # # # # # # # # #
# handle file editing #
# # # # # # # # # # # #

my $param = '/var/smoothwall/mods/nowireap/params';

&easymod ("/home/httpd/cgi-bin/.htaccess", "$param/htaccess.02.s", '3', "$param/htaccess.02.r");

if (&installed ("/home/httpd/cgi-bin/.htaccess", "<Files blue-if.cgi>")) {
	print "\nBlue Interface htaccess rules already exist.\n\n";
} else {
	&easymod ("/home/httpd/cgi-bin/.htaccess", "$param/htaccess2.02.s", '3', "$param/htaccess2.02.r");
}

&easymod ("/var/smoothwall/main/ui/alertboxes.en.pl", "$param/alertboxes.en.pl.02.s", '0', "$param/alertboxes.en.pl.02.r");

&easymod ("/var/smoothwall/header.pl", "$param/header.pl.02.s", '0', "$param/header.pl.02.r");

&easymod ("/var/smoothwall/langs/base.pl", "$param/base.pl.02.s", '0', "$param/base.pl.02.r");

&easymod ("/etc/ld.so.conf", "$param/ld.so.conf.02.s", '0', "$param/ld.so.conf.02.r");	# so that iwconfig will work 
system ('/sbin/ldconfig');

#if (&installed ("/etc/rc.d/rc.firewall.up", 'if [ "$BLUE_DEV" != "" ]; then')) {
if (&installed ("/etc/rc.d/rc.firewall.up", '   /sbin/iptables -A FORWARD -m state --state NEW -i $BLUE_DEV -o ppp0 -j ACCEPT')) {
	print "\nPost-Fixes9 Blue Interface Fix by s-t-p already exists.\n\n";
} else {
	# post-fixes9 blue interface fix by s-t-p
	if (-e "/var/smoothwall/mods/full-firewall/installed") {	# check if full-firewall controll is installed
		&easymod ("/etc/rc.d/rc.firewall.up", "$param/rc.firewall.up.02b.s", '1', "$param/rc.firewall.up.02b.r");

	} else {
		&easymod ("/etc/rc.d/rc.firewall.up", "$param/rc.firewall.up.02.s", '5', "$param/rc.firewall.up.02.r");
	}
}

if (&installed ("/etc/rc.d/rc.firewall.up", "# Allow BLUE to talk to ORANGE")) {
	print "\nAllow BLUE to talk to ORANGE tweak by s-t-p already exists.\n\n";
} else {	# blue-if fails to patch if full-firewall control is installed?
	# Allow BLUE to talk to ORANGE tweak by s-t-p
		&easymod ("/etc/rc.d/rc.firewall.up", "$param/rc.firewall.up2.02.s", '1', "$param/rc.firewall.up2.02.r");
}

if (&installed ("/etc/rc.d/rc.firewall.up", "# For transparent proxy/DNAT.")) {
	print "\nFor Blue Interface transparent proxy/DNAT. already exists.\n\n";
} else {	# blue-if fails to patch if full-firewall control is installed
	# For transparent proxy/DNAT.
	&easymod ("/etc/rc.d/rc.firewall.up", "$param/rc.firewall.up3.02.s", '0', "$param/rc.firewall.up3.02.r");
}

&easymod ("/etc/rc.d/rc.netaddress.up", "$param/rc.netaddress.up.02.s", '0', "$param/rc.netaddress.up.02.r");

#&easymod ("/etc/rc.d/rc.netaddress.up", "$param/rc.netaddress.up2.02.s", '2', "$param/rc.netaddress.up2.02.r");

if (&installed ("/etc/rc.d/rc.network", "for NIC in 0; do")) {
	print "\nblue interface ath0 wireless nic support by Noven already exists.\n\n";
} else {
	# blue interface ath0 wireless nic support by Noven
	&easymod ("/etc/rc.d/rc.network", "$param/rc.network.02.s", '1', "$param/rc.network.02.r");
}
&easymod ("/etc/rc.d/rc.sysinit", "$param/rc.sysinit.02.s", '1', "$param/rc.sysinit.02.r");


# # # # # # # # # # # #
# handle file linking #
# # # # # # # # # # # #

#print "Creating GUI linked image ...\n";

#system ('/bin/ln -s /home/httpd/html/ui/assets/3.6/img/pagetitles/title-networking.png /home/httpd/html/ui/assets/3.6/img/pagetitles/page-nowireap.png');
system ('/bin/ln -s /home/httpd/html/ui/assets/3.6/img/pagetitles/title-networking.png /home/httpd/html/ui/assets/3.6/img/pagetitles/page-wireless.png');

$mod = '/var/smoothwall/mods/nowireap/modfiles';
$dir = '/var/smoothwall/mods/nowireap';
&install ('installed', $dir, $mod);

print "\nDone\n\n";

# # # #
# end #
# # # #
